Summary: GNU C Compiler
Name: gcc
Version: 2.7.2.3
Release: 5
Copyright: GPL
Packager: Trond Eivind Glomsrd <teg@pvv.ntnu.no>
Group: Development/Languages
Source0: ftp://prep.ai.mit.edu/pub/gnu/gcc-2.7.2.3.tar.gz
Source1: ftp://prep.ai.mit.edu/pub/gnu/g77-0.5.21.tar.gz
Provides: gcc-compiled-with-g77-2.7.2.3
BuildRoot: /usr/src/gcc_root

%description

The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++,
Objective C  and FORTRAN 77 compilers as well. This package
_must_ be installed for the g77 rpm to work.


%changelog
* Sun Nov 2 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
  [gcc-2.7.2.3-5]
  - some small changes so that the SRPM should build on both glibc
    and libc5 based systems.
* Thu Oct 30 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
  [gcc-2.7.2.3-4]
  - some small changes to build with glibc
* Mon Oct 13 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
  [gcc-2.7.2.3-3]
  - Now uses BuildRoot
  - Changed the system for including files
* Mon Sep 15 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
  [gcc-2.7.2.3-2]
  - Added a %changelog entry
  - included some missing *.o-files

%package c++
Requires: gcc-compiled-with-g77-2.7.2.3
Summary: C++ support for gcc
Group: Development/Languages


%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Requires: gcc-compiled-with-g77-2.7.2.3
Summary: Objective C support for gcc
Group: Development/Languages


%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%package g77
Requires: gcc-compiled-with-g77-2.7.2.3
Summary: FORTRAN 77 support for gcc
Group: Development/Languages

%description g77
This package adds FORTRAN 77 support to the GNU C compiler. FORTRAN 77
is widely used in scientific computing and calculations. This is
version 0.5.21

%prep

rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/lib
mkdir -p $RPM_BUILD_ROOT/usr/include



%setup -n gcc-2.7.2.3
%setup  -D -T -a 1 -n gcc-2.7.2.3
mv -f g77-0.5.21/* .
rmdir g77-0.5.21/
patch -p1 -s  < f/gbe/2.7.2.3.diff

touch f77-install-ok
touch f2c-install-ok

%build

./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++

make LANGUAGES=c CFLAGS="$RPM_OPT_FLAGS"
make stage1 CFLAGS="$RPM_OPT_FLAGS"
make CC="stage1/xgcc -Bstage1/" CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s"
make prefix=$RPM_BUILD_ROOT/usr install


# For Objective C only
make objc-runtime CC="stage1/xgcc -Bstage1/" CFLAGS="-O2 -m486" LDFLAGS="-s"

%install
make CC="stage1/xgcc -Bstage2/" CFLAGS="-O2 -m486" LDFLAGS="-s" prefix=$RPM_BUILD_ROOT/usr install

# For Objective C only
make prefix=$RPM_BUILD_ROOT/usr install-libobjc CC="stage2/xgcc -Bstage1/" CFLAGS="-O2 -m486" LDFLAGS="-s"

rm -f $RPM_BUILD_ROOT/usr/info/dir
gzip -n -9f $RPM_BUILD_ROOT/usr/info/*
ln $RPM_BUILD_ROOT/usr/bin/gcc $RPM_BUILD_ROOT/usr/bin/cc

mv -f /usr/local/include/f2c.h $RPM_BUILD_ROOT/usr/include/f2c.h

ln -sf ../usr/lib/gcc-lib/*linux*/2.7.2.3.f.1/cpp $RPM_BUILD_ROOT/lib/cpp

find $RPM_BUILD_ROOT -name "*.1"  -type f -not -type l -exec gzip -f9 {} \;


# Find the files in the main package

find $RPM_BUILD_ROOT -not -type d | grep -v 77 | grep -v plus | grep -v f2 | grep -v obj | grep -v "++" | grep -v -E "/lib/cpp$" | /usr/bin/perl -pe "s/.*(\/usr.*)/\1/" > gccfiles 
echo "/lib/cpp" >> gccfiles

#The files for FORTRAN 77 support

find $RPM_BUILD_ROOT -name "*77*" -type f -or -name "*f2*" -type f | grep -v /usr/doc | /usr/bin/perl -pe "s/.*(\/usr.*)/\1/" > g77files

# The files for objective C

find $RPM_BUILD_ROOT -name "*obj*" -type f | /usr/bin/perl -pe "s/.*(\/usr.*)/\1/" |grep -v include > objcfiles 
find $RPM_BUILD_ROOT -name "objc" -type d |  /usr/bin/perl -pe "s/.*(\/usr.*)/\1/" >> objcfiles

# The files for C++ support

find $RPM_BUILD_ROOT -name "*++*" -or -name "*plus*" -type f | /usr/bin/perl -pe "s/.*(\/usr.*)/\1/" > gppfiles 

%clean
rm -fr $RPM_BUILD_ROOT

%files -f gccfiles
%doc BUGS COPYING ChangeLog NEWS ORDERS PROJECTS README README.X11

%files c++ -f gppfiles

%files objc -f objcfiles

%files g77 -f g77files 
%doc README.g77 


